             .title        "Irem TAM-S1 Reader Plugin"

;07/16/09 
;Written by BootGod
;Version 1.0
;Only 1 known cart, so no size detection, fixed to 256K
             
;vectors for standard system calls
send_byte:   .equ 0200h
baton:       .equ 0203h
chk_vram:    .equ 0206h
chk_wram:    .equ 0209h
wr_ppu:      .equ 020ch
read_byte:   .equ 020fh
init_crc:    .equ 0212h
do_crc:      .equ 0215h
finish_crc:  .equ 0218h

crc0:        .equ 0080h
crc1:        .equ 0081h
crc2:        .equ 0082h
crc3:        .equ 0083h

addr:		.equ 00e0h
addr_lo:	.equ 00e0h
addr_hi:	.equ 00e1h
curbank:	.equ 00e2h
banksleft:	.equ 00e3h

;plugin header defines
p_ver: = 1      ;plugin version
p_read: = 1	;plugin is for downloading (dumping)
p_write: = 2	;plugin is for uploading (RAM carts / WRAM etc)
p_other: = 3	;plugin is for some other purpose (i.e. BankWatch)
p_var1: = 4	;plugin uses user variable #1
p_var2: = 8	;plugin uses user variable #2
p_var3: = 16	;plugin uses user variable #3
p_var4: = 32	;plugin uses user variable #4

;plugin header data

             .org 0380h
             
             ;plugin description
             .db "Irem TAM-S1 carts"
             .fill 03e0h-*,00h

             ;plugin creator(s)
             .db "BootGod"
             .fill 03f8h-*,00h

             ;PRG/CHR/WRAM min/max sizes supported
             .db 256 >> 4,0 >> 4
             .db 0 >> 3,0 >> 3
             .db 0,0

             ;plugin version and flags
             .db p_ver
             .db p_read

;plugin code start here
             
             lda #4
             jsr send_byte	;mirror under mapper control
             

init_prg:    lda #0
             sta curbank
             jsr send_byte
             lda #4
             jsr send_byte	;report 256K
             lda #1
             jsr send_byte	;send PRG header

             lda #16
             sta banksleft	;16 x 16K

next_bank:   lda curbank
             sta 08000h
             inc curbank
             lda #0
             tay
             sta addr_lo
             lda #0c0h
             sta addr_hi	;0xC000 is the swappable bank

send_bank:   lda (addr),y
             jsr send_byte
             iny
             bne send_bank
             inc addr_hi
             bne send_bank
             
             dec banksleft
             bne next_bank
 
done:        lda #0
             jsr send_byte
             lda #0
             jsr send_byte
             lda #0
             jsr send_byte	;send end block
             rts

             .fill 0800h-*,0ffh	;fill rest to get 1K of data

             .end
